#!/bin/sh

export LD_LIBRARY_PATH=/lib:/system/lib:/usr/lib

##check MCU upgrade.
#/system/init/mcu_update.sh
/system/init/gpio_set.sh

echo 1 > /proc/sys/vm/overcommit_memory
#echo 3072 > /proc/sys/vm/min_free_kbytes
echo 3 > /proc/sys/vm/drop_caches
echo 0 4 1 7 > /proc/sys/kernel/printk

## power on wifi module:
if [ ! -d /sys/class/gpio/gpio52 ]; then
    /bin/echo 52 > /sys/class/gpio/export
fi
DIRECTION=`cat /sys/class/gpio/gpio52/direction`
if [ "$DIRECTION" != "out" ]; then
    /bin/echo -e "==== gpio52 direction: $DIRECTION, change to 'out' ===="
    /bin/echo out > /sys/class/gpio/gpio52/direction
fi
/bin/echo 0 > /sys/class/gpio/gpio52/value
/bin/sleep 2
/bin/echo 1 > /sys/class/gpio/gpio52/value
/bin/sleep 1

ifconfig lo 127.0.0.1 up

## add for ipv4:
sysctl -w net.ipv4.tcp_fin_timeout=30
sysctl -w net.ipv4.tcp_timestamps=1
sysctl -w net.ipv4.tcp_tw_recycle=1
sysctl -w net.ipv4.tcp_tw_reuse=1
##end.

## /* load drivers */
insmod /lib/modules/avpu.ko
#insmod /lib/modules/sinfo.ko
#echo 1 >/proc/jz/sinfo/info
#SENSOR_INFO=`cat /proc/jz/sinfo/info`
#echo ${SENSOR_INFO}
insmod /lib/modules/tx-isp-t31.ko isp_clk=125000000
insmod /lib/modules/audio.ko
#insmod /lib/modules/sensor_gc2053_t31.ko #error.
insmod /lib/modules/sensor_gc2053_t31.ko sensor_max_fps=25 data_interface=1
insmod /lib/modules/exfat.ko

#exfat.ko insmod later than auto sd mount, so we need mount exfat sd card in this time.
if [ -e /dev/mmcblk0p1 ]; 
then
#    mount /dev/mmcblk0p1 /media
#    mount -o utf8=1 -o noatime /dev/mmcblk0p1 /media
#    echo "---- mount 1 ----"
    mount -o utf8=1 -o dirsync -o nodiratime -o noatime -o nodev -o nosuid -o noexec /dev/mmcblk0p1 /media
#    echo "---- mount 2 ----"
    mount -o dirsync -o nodiratime -o noatime -o nodev -o nosuid -o noexec /dev/mmcblk0p1 /media
    echo -e "++++++++++++++ exFAT mount success +++++++++++++++"
fi

## add for remove /media/video while device unbound by user:                                              
/system/init/device_unbind.sh &

chmod a+x /system/init/*
cp /system/init/set_ircut /tmp/

## /*check upgrade firmware*/
/bin/sh /system/init/babycam_check_upgrade.sh

## /*modify for sleepTrack.*/
if [ -f /media/SleepTrackInfo.db ]
then
    /bin/mv -f /media/SleepTrackInfo.db /system/init/
fi
if [ -d /media/resend_sleep ]
then
    /bin/mv -f /media/resend_sleep /system/init/
fi
##end.

##load wifi driver:
WIFI_RTL8811CU=c811
WIFI_RTL8188EUS=8179
##############################################################################
## verify wifi module ID by command as follow:
##   lsusb | head -1 | awk '{print $6}' |awk -F ":" '{print $2}'
##      ==> c811: rtl8811cu.
##      ==> 8179: rtl8188eus.
##############################################################################
lsusb
WIFI_ID=`lsusb | head -1 | awk '{print $6}' | awk -F ":" '{print $2}'`
/bin/echo -e ">>>>>>>>> WIFI_ID: $WIFI_ID"
/bin/echo -e "$(date) >>>>>>>>> WIFI_ID: $WIFI_ID" >> /system/init/syslog.txt
if [ "${WIFI_ID}" = "${WIFI_RTL8811CU}" ]; then
    /bin/echo -e "=========== wifi module: RTL8811CU (wext) ==========="
    /bin/echo -e "$(date) =========== wifi module: RTL8811CU (wext) ===========" >> /system/init/syslog.txt

    if [ -f /lib/firmware/8188eu.ko ]; then
        echo -e "-------- matched rtl8821cu, remove 8188eu.ko --------"
        echo -e "$(date) -------- matched rtl8821cu, remove 8188eu.ko --------" >> /system/init/syslog.txt
        /bin/rm -f /system/lib/firmware/8188eu.ko
    fi

    ##/*check forrtl8821cu.ko update.*/
    while [ -f /media/rtl8821cu.ko ]
    do
        MD5_MEDIA_8811CU=`md5sum /media/rtl8821cu.ko | awk '{print $1}'`
        MD5_SYSTEM_8811CU=`md5sum /system/lib/firmware/rtl8821cu.ko | awk '{print $1}'`
        /bin/echo -e ">>>>>>>>> md5_media_8811cu: ${MD5_MEDIA_8811CU}"
        /bin/echo -e ">>>>>>>>> md5_system_8811cu: ${MD5_SYSTEM_8811CU}"
        if [ "${MD5_MEDIA_8811CU}" = "${MD5_SYSTEM_8811CU}" ]; then
            /bin/echo -e "++++++++ rtl8821cu.ko >>> md5 matched success ++++++++"
            /bin/echo -e "$(date) ++++++++ rtl8821cu.ko >>> md5 matched success ++++++++" >> /system/init/syslog.txt
            rm -f /media/rtl8821cu.ko
        else
            /bin/echo -e ">>>>>> md5 not matched, need to update rtl8821cu.ko >>>>>>"
            /bin/echo -e "$(date) >>>>>> md5 not matched, need to update rtl8821cu.ko >>>>>>" >> /system/init/syslog.txt
            /bin/cp -f /media/rtl8821cu.ko /system/lib/firmware/
            sync
            sleep 2
            continue
        fi
        sync
        break
    done
elif [ "${WIFI_ID}" = "${WIFI_RTL8188EUS}" ]; then
    /bin/echo -e "=========== wifi module: RTL8188EUS (nl80211) ==========="
    /bin/echo -e "$(date) =========== wifi module: RTL8188EUS (nl80211) ===========" >> /system/init/syslog.txt

    if [ -f /lib/firmware/rtl8821cu.ko ]; then
        echo -e "-------- matched 8188eus, remove rtl8821cu.ko --------"
        echo -e "$(date) -------- matched 8188eus, remove rtl8821cu.ko --------" >> /system/init/syslog.txt
        /bin/rm -f /system/lib/firmware/rtl8821cu.ko
    fi

    ##/*check for 8188eu.ko update.*/
    while [ -f /media/8188eu.ko ]
    do
        MD5_MEDIA_8188EU=`md5sum /media/8188eu.ko | awk '{print $1}'`
        MD5_SYSTEM_8188EU=`md5sum /system/lib/firmware/8188eu.ko | awk '{print $1}'`
        /bin/echo -e ">>>>>>>>> md5_media_8188eu: $MD5_MEDIA_8188EU"
        /bin/echo -e ">>>>>>>>> md5_system_8188eu: $MD5_SYSTEM_8188EU"
        if [ "$MD5_MEDIA_8188EU" = "$MD5_SYSTEM_8188EU" ]; then
            /bin/echo -e "++++++++ 8188eu.ko >>> md5 matched success ++++++++"
            /bin/echo -e "$(date) ++++++++ 8188eu.ko >>> md5 matched success ++++++++" >> /system/init/syslog.txt
            rm -f /media/8188eu.ko
        else
            /bin/echo -e ">>>>>> md5 not matched, need to update 8188eu.ko >>>>>>"
            /bin/echo -e "$(date) >>>>>> md5 not matched, need to update 8188eu.ko >>>>>>" >> /system/init/syslog.txt
            /bin/cp -f /media/8188eu.ko /system/lib/firmware/
            sync
            sleep 2
            continue
        fi
        sync
        break
    done
fi
/sbin/insmod /lib/firmware/*u.ko
echo "======== load wifi driver end ========"

/sbin/ifconfig wlan0 up
for i in 1 2 3; do
temp=`ifconfig |grep wlan| awk '{print $1}'`
echo "-------- temp: $temp --------"
if [ "$temp" == "wlan0" ];then
    echo "############ wlan0 exist ############"
    break
else
    echo "!!!!!! <app_init.sh> wlan0 is not found, maybe wireless module is abnormal, try: $i !!!!!!"
    echo "$(date) !!!!!! <app_init.sh> wlan0 is not found, maybe wireless module is abnormal, try: $i !!!!!!" >> /system/init/syslog.txt
    /sbin/ifconfig wlan0 down
    sleep 3
    ifconfig wlan0 up
fi
done

## /* start wifi station mode connect */
/system/init/wifi_sta.sh

## /* save log into syslog.txt */
#klogd -n &
#syslogd -l 4 -s 128 -f /system/init/syslog.conf
syslogd -l 4 -s 256 -f /system/init/syslog.conf
/system/init/reboot.sh &

## /*check libjzdl.m.so existence.*/
if [ -f /usr/lib/libjzdl.m.so ]; then
    echo "====== found /usr/lib/libjzdl.m.so success ======"
else
    echo "!!!!!! not found /usr/lib/libjzdl.m.so !!!!!!" >> /system/init/syslog.txt
    if [ -f /system/lib/libjzdl.m.so ]; then
        echo "====== found /system/lib/libjzdl.m.so success ======"
    else
        echo "!!!!!! not found /system/lib/libjzdl.m.so !!!!!!" >> /system/init/syslog.txt
    fi
fi

## /*run applications*/
echo -e "$(date) >>>>>> babymonitor application start......" >> /system/init/syslog.txt
/system/bin/simbaby_daemon.sh &
/system/bin/babymonitor &

