#!/bin/sh

WPA_CONFIG_FILE="/system/init/wpa_supplicant.conf"
WIFI_RTL8811CU=c811
WIFI_RTL8188EUS=8179
WIFI_UNKNOWN=0002

umount -l /mnt

/usr/bin/pkill -9 udhcpc
/usr/bin/pkill -9 wpa_supplicant
/usr/bin/pkill -9 udpchd
/usr/bin/pkill -9 hostapd

##############################################################################
## verify wifi module ID by command as follow:
##   lsusb | head -1 | awk '{print $6}' |awk -F ":" '{print $2}'
##      ==> c811: rtl8811cu.
##      ==> 8179: rtl8188eus.
##      ==> 0002: wifi ID unrecognized.
##############################################################################
lsusb
if [ -f $WPA_CONFIG_FILE ]; then
    /bin/echo -e "=========== ReStart Wifi STA Mode ==========="
    WIFI_ID=`lsusb | head -1 | awk '{print $6}' | awk -F ":" '{print $2}'`
    /bin/echo -e " <wifi_reconnect.sh> >>>>>>>> WIFI_ID: $WIFI_ID"
    /bin/echo -e "$(date)  <wifi_reconnect.sh> >>>>>>>> WIFI_ID: $WIFI_ID" >> /system/init/syslog.txt
    if [ "${WIFI_ID}" = "${WIFI_RTL8811CU}" ]; then
        /bin/echo -e "=====wifi_reconnect.sh====== wifi module: RTL8811CU (wext) ==========="
        /bin/echo -e "$(date) =====wifi_reconnect.sh====== wifi module: RTL8811CU (wext) ===========" >> /system/init/syslog.txt
        /sbin/ifconfig wlan0 down
        /sbin/rmmod 8821cu
        /bin/sleep 2
        /sbin/insmod /lib/firmware/rtl8821cu.ko
        /bin/sleep 2
        echo 3 > /proc/net/rtl8821cu/log_level
        /sbin/ifconfig wlan0 up

        ##检查wlan0节点是否存在.
        for i in 1 2 3; do
            temp=`ifconfig |grep wlan| awk '{print $1}'`
            echo "-------- temp: $temp --------"
            if [ "$temp" == "wlan0" ];then
                echo "############ wlan0 exist ############"
                break
            else
                echo "!!!!!! <wifi_reconnect.sh> wlan0 is not found, maybe wireless module is abnormal, try: $i !!!!!!"
                echo "$(date) !!!!!! <wifi_reconnect.sh> wlan0 is not found, maybe wireless module is abnormal, try: $i !!!!!!" >> /system/init/syslog.txt
                sleep 2
                ifconfig wlan0 up
            fi
        done

#        /bin/wpa_supplicant -D wext -i wlan0 -c /system/init/wpa_supplicant.conf -dd -B
        /bin/wpa_supplicant -D wext -i wlan0 -c /system/init/wpa_supplicant.conf -B
        /bin/wpa_cli -i wlan0 -p /var/run/wpa_supplicant select_network 0
        /bin/wpa_cli -i wlan0 -p /var/run/wpa_supplicant sta_autoconnect 1
        /bin/sleep 1
        /sbin/udhcpc -i wlan0 &
    elif [ "${WIFI_ID}" = "${WIFI_RTL8188EUS}" ]; then
        /bin/echo -e "=====wifi_reconnect.sh====== wifi module: RTL8188EUS (nl80211) ==========="
        /bin/echo -e "$(date) =====wifi_reconnect.sh====== wifi module: RTL8188EUS (nl80211) ===========" >> /system/init/syslog.txt
        /sbin/ifconfig wlan0 down
        /sbin/rmmod 8188eu
        ## power reset wifi module for RTL8188EUS:
        #/bin/echo 52 > /sys/class/gpio/export
        #/bin/echo out > /sys/class/gpio/gpio52/direction
        if [ ! -d /sys/class/gpio/gpio52 ]; then
            /bin/echo 52 > /sys/class/gpio/export
        fi
        DIRECTION=`cat /sys/class/gpio/gpio52/direction`
        if [ "$DIRECTION" != "out" ]; then
            echo -e "====wifi_reconnect.sh==== gpio52 direction: $DIRECTION, change to 'out' ===="
            echo -e "$(date) ====wifi_reconnect.sh==== gpio52 direction: $DIRECTION, change to 'out' ====" >> /system/init/syslog.txt
            /bin/echo out > /sys/class/gpio/gpio52/direction
        fi
        /bin/echo 0 > /sys/class/gpio/gpio52/value
        /bin/sleep 3
        /bin/echo 1 > /sys/class/gpio/gpio52/value
        /bin/sleep 2
        /sbin/insmod /lib/firmware/8188eu.ko
        /bin/sleep 2
        echo 3 > /proc/net/rtl8188eu/log_level
        /sbin/ifconfig wlan0 up

        ##检查wlan0节点是否存在.
        for i in 1 2 3; do
            temp=`ifconfig |grep wlan| awk '{print $1}'`
            echo "-------- temp: $temp --------"
            if [ "$temp" == "wlan0" ];then
                echo "############ wlan0 exist ############"
                break
            else
                echo "!!!!!! <wifi_reconnect.sh> wlan0 is not found, maybe wireless module is abnormal, try: $i !!!!!!"
                echo "$(date) !!!!!! <wifi_reconnect.sh> wlan0 is not found, maybe wireless module is abnormal, try: $i !!!!!!" >> /system/init/syslog.txt
                sleep 2
                ifconfig wlan0 up
            fi
        done

#        /bin/wpa_supplicant -D nl80211 -i wlan0 -c /system/init/wpa_supplicant.conf -dd -B
        /bin/wpa_supplicant -D nl80211 -i wlan0 -c /system/init/wpa_supplicant.conf -B
        /bin/wpa_cli -i wlan0 -p /var/run/wpa_supplicant select_network 0
        /bin/wpa_cli -i wlan0 -p /var/run/wpa_supplicant sta_autoconnect 1
        /bin/sleep 1
        /sbin/udhcpc -i wlan0 &
    elif [ "${WIFI_ID}" = "${WIFI_UNKNOWN}" ]; then
        #########################################################################
        ##  lsusb未识别出wifi型号时,在/lib/firmware目录下查找wifi驱动文件.
        #########################################################################
        if [ -f /lib/firmware/rtl8821cu.ko ]; then
            ######################################################
            ##  在/lib/firmware目录下查找rtl8821cu.ko驱动文件.
            ######################################################
            /bin/echo -e "====wifi_reconnect.sh==== unrecognized wifi module, found rtl8821cu.ko ==========="
            /bin/echo -e "$(date) ====wifi_reconnect.sh==== unrecognized wifi module, found rtl8821cu.ko ===========" >> /system/init/syslog.txt
            /sbin/ifconfig wlan0 down
            /sbin/rmmod 8821cu
            /bin/sleep 2
            /sbin/insmod /lib/firmware/rtl8821cu.ko
            /bin/sleep 2
            echo 3 > /proc/net/rtl8821cu/log_level
            /sbin/ifconfig wlan0 up

            ##检查wlan0节点是否存在.
            for i in 1 2 3; do
                temp=`ifconfig |grep wlan| awk '{print $1}'`
                echo "-------- temp: $temp --------"
                if [ "$temp" == "wlan0" ];then
                    echo "############ wlan0 exist ############"
                    break
                else
                    echo "!!!!!! <wifi_reconnect.sh> wlan0 is not found, maybe wireless module is abnormal, try: $i !!!!!!"
                    echo "$(date) !!!!!! <wifi_reconnect.sh> wlan0 is not found, maybe wireless module is abnormal, try: $i !!!!!!" >> /system/init/syslog.txt
                    sleep 2
                    ifconfig wlan0 up
                fi
            done

#            /bin/wpa_supplicant -D wext -i wlan0 -c /system/init/wpa_supplicant.conf -dd -B
            /bin/wpa_supplicant -D wext -i wlan0 -c /system/init/wpa_supplicant.conf -B
            /bin/wpa_cli -i wlan0 -p /var/run/wpa_supplicant select_network 0
            /bin/wpa_cli -i wlan0 -p /var/run/wpa_supplicant sta_autoconnect 1
            /bin/sleep 1
            /sbin/udhcpc -i wlan0 &
        elif [ -f /lib/firmware/8188eu.ko ]; then
            ######################################################
            ##  在/lib/firmware目录下查找8188eu.ko驱动文件.
            ######################################################
            /bin/echo -e "====wifi_reconnect.sh==== unrecognized wifi module, found 8188eu.ko ==========="
            /bin/echo -e "$(date) ====wifi_reconnect.sh==== unrecognized wifi module, found 8188eu.ko ===========" >> /system/init/syslog.txt
            /sbin/ifconfig wlan0 down
            /sbin/rmmod 8188eu
            ## power reset wifi module for RTL8188EUS:
            #/bin/echo 52 > /sys/class/gpio/export
            #/bin/echo out > /sys/class/gpio/gpio52/direction
            if [ ! -d /sys/class/gpio/gpio52 ]; then
                /bin/echo 52 > /sys/class/gpio/export
            fi
            DIRECTION=`cat /sys/class/gpio/gpio52/direction`
            if [ "$DIRECTION" != "out" ]; then
                echo -e "====wifi_reconnect.sh==== gpio52 direction: $DIRECTION, change to 'out' ===="
                echo -e "$(date) ====wifi_reconnect.sh==== gpio52 direction: $DIRECTION, change to 'out' ====" >> /system/init/syslog.txt
                /bin/echo out > /sys/class/gpio/gpio52/direction
            fi
            /bin/echo 0 > /sys/class/gpio/gpio52/value
            /bin/sleep 2
            /bin/echo 1 > /sys/class/gpio/gpio52/value
            /bin/sleep 2
            /sbin/insmod /lib/firmware/8188eu.ko
            /bin/sleep 2
            echo 3 > /proc/net/rtl8188eu/log_level
            /sbin/ifconfig wlan0 up

            ##检查wlan0节点是否存在.
            for i in 1 2 3; do
                temp=`ifconfig |grep wlan| awk '{print $1}'`
                echo "-------- temp: $temp --------"
                if [ "$temp" == "wlan0" ];then
                    echo "############ wlan0 exist ############"
                    break
                else
                    echo "!!!!!! <wifi_reconnect.sh> wlan0 is not found, maybe wireless module is abnormal, try: $i !!!!!!"
                    echo "$(date) !!!!!! <wifi_reconnect.sh> wlan0 is not found, maybe wireless module is abnormal, try: $i !!!!!!" >> /system/init/syslog.txt
                    sleep 2
                    ifconfig wlan0 up
                fi
            done

#            /bin/wpa_supplicant -D nl80211 -i wlan0 -c /system/init/wpa_supplicant.conf -dd -B
            /bin/wpa_supplicant -D nl80211 -i wlan0 -c /system/init/wpa_supplicant.conf -B
            /bin/wpa_cli -i wlan0 -p /var/run/wpa_supplicant select_network 0
            /bin/wpa_cli -i wlan0 -p /var/run/wpa_supplicant sta_autoconnect 1
            /bin/sleep 1
            /sbin/udhcpc -i wlan0 &
        fi
    fi
else
    echo -e "************ <wifi_reconnect.sh> $WPA_CONFIG_FILE is not exist, restart wifi sta mode failed ************"
    echo -e "$(date) ************ <wifi_reconnect.sh> $WPA_CONFIG_FILE is not exist, restart wifi sta mode failed ************" >> /system/init/syslog.txt
fi

