#!/bin/sh

WPA_CONFIG_FILE="/system/init/wpa_supplicant.conf"
WIFI_RTL8811CU=c811
WIFI_RTL8188EUS=8179

umount -l /mnt

##############################################################################
## verify wifi module ID by command as follow:
##   lsusb | head -1 | awk '{print $6}' |awk -F ":" '{print $2}'
##      ==> c811: rtl8811cu.
##      ==> 8179: rtl8188eus.
##############################################################################
if [ -f $WPA_CONFIG_FILE ]; then
    /bin/echo "=========== Wifi STA Mode Start ==========="
    WIFI_ID=`lsusb | head -1 | awk '{print $6}' | awk -F ":" '{print $2}'`
    echo -e ">>>>>>>>> WIFI_ID: $WIFI_ID"
    /usr/bin/pkill -9 udhcpc
    /usr/bin/pkill -9 wpa_supplicant
    /usr/bin/pkill -9 udpchd
    /usr/bin/pkill -9 hostapd
    /sbin/ifconfig wlan0 down
    /bin/sleep 2
    /sbin/ifconfig wlan0 up
    if [ "${WIFI_ID}" = "${WIFI_RTL8811CU}" ]; then
        /bin/echo -e "=========== wifi module: RTL8811CU (wext) ==========="
        echo 3 > /proc/net/rtl8821cu/log_level
        /bin/wpa_supplicant -D wext -i wlan0 -c $WPA_CONFIG_FILE -B
    else
        /bin/echo -e "=========== wifi module: RTL8188EUS (nl80211) ==========="
        echo 3 > /proc/net/rtl8188eu/log_level
        /bin/wpa_supplicant -D nl80211 -i wlan0 -c $WPA_CONFIG_FILE -B
    fi
    /bin/wpa_cli -i wlan0 -p /var/run/wpa_supplicant select_network 0
    /bin/wpa_cli -i wlan0 -p /var/run/wpa_supplicant sta_autoconnect 1
    /bin/sleep 2
    /sbin/udhcpc -i wlan0 &
else
    echo -e "************ $WPA_CONFIG_FILE is not exist, maybe it's the time for QR-Code scanning ************"
    echo -e "************ $WPA_CONFIG_FILE is not exist, maybe it's the time for QR-Code scanning ************" >> /system/init/syslog.txt
fi
